#ifndef MUD_H
#define MUD_H

#include <vector>
#include "hashgrid.h"
#include "collisions.h"

struct Mud
{
   int n; // number of particles
   std::vector<Vec3f> x, v, f, oldx;
   HashGrid3D grid;
   float mass; // mass of each particle
   float spring_stiffness, spring_damping, spring_restlength;
   float radius_of_influence;;
   float air_drag;
   float max_dt;
   float gravity;
   Collisions collisions;
   
   Mud(float mass_=0.004, float spring_stiffness_=0.5, float spring_damping_=0.01, float spring_restlength_=0.01,
       float radius_of_influence_=0.025, float air_drag_=0.01)
      : n(0), grid(x,radius_of_influence_), mass(mass_), spring_stiffness(spring_stiffness_), spring_damping(spring_damping_),
        spring_restlength(spring_restlength_), radius_of_influence(radius_of_influence_), gravity(9.8)
   {
      // @@@ Here you need to write code to compute max_dt
      max_dt=0; // this is wrong!
   }

   void init_sphere(const Vec3f &centre, float radius);
   void advance_frame(float frame_dt);
   void write_output(char *filename_format, ...);

   private:
   void advance_time_step(float dt);
   void compute_forces();
};

#endif
